Subject: Re: yaboot problems (still -- suggestions welcome!)

From: Ethan Benson <[email-masked]>
Date: Wed, 24 May 2000 22:50:02 -0800

On Wed, May 24, 2000 at 05:52:23PM -0400, Tom wrote:
> I've been struggling with it for over a week now, but am still unable to
> 
> yaboot (though I think I've made some minimal progress).
> 
> I have a G4/500 with linux on a dedicated external scsi drive (Adaptec
> 2906 card).
> 
> Per OF, the card corresponds to:
> /pci@f2000000/pci-bridge@d/pci9004,7850@2/@2  (It is device 2 on the
> scsi chain, or at least that's what the back of the hard drive implies.)
> 
> pdisk says the bootstrap partition is #2:
> Partition map (with 512 byte blocks) on '/dev/sda'
>  #:                type name                   length   base    ( size )
> 
>  1:    Apple_UNIX_SVR2 /            7785303 @ 204     (  3.7G)
>  2:    Apple_HFS "bootstrap"         65638 @ 7785507 ( 32.0M)

this is a waste of space, since your swap partition is right below
perhaps you would want to delete them both and create the bootstrap
partition as 800K and the swap partition as 544.  

you should at the very least delete it and recreate it with the
correct Apple_Bootstrap partition type, otherwise macos will screw it
up. 

>  3:    Apple_UNIX_SVR2 swap    1048592 @ 7851145 (512.0M)
>  [rest deleted]
> 
> Set the relevant line in /boot/ofboot.b (which is cp'd from the
> menu_ofboot.b):
> " Booting Yaboot ..." cr " boot sd:2,yaboot" eval
> 
> My /etc/yaboot.conf is as follows:
> --------------
> default=Linux-Stable
> 
> ## change to your bootstrap partition ie /dev/hda2
> boot=/dev/sda2
> device=sd:
> timeout=20
> install=/boot/yaboot
> magicboot=/boot/ofboot.b
> 
> image=/boot/vmlinux
>  label=Linux-Stable
>  root=/dev/sda1
>  read-only
>  partition=2
> 
> append= "video=aty128fb:vmode:17;cmode:24"
> -----------------
> 
> Now, in OF, when I try to set sd as a devalias, it tells me the nvramrc
> isn't valid.  When I printenv, I don't see it showing up anywhere (but
> maybe I don't know what to look for, exactly?).

nvalias is the proper command to create an alias, though i find it
simpler to just enter the full path in yaboot.conf and ofboot.b.  that
way you 1) don't have to fsck with OF.  and 2) don't have to fsck with
OF if your nvram gets erased.

> When in OF and I try to boot directly by providing the OF path manually,
> 
> I get this error:
> method <open> not found ; ihandle=ff9c4980 phandle=ff8a9708 method
> <close> not found ihandle=ff9c4980 phandle=ff8a9708 can't OPEN:
> /pci@f2000000/.... {etc}.
> I don't know what this means or what to do with this information.
> (Anyone have any idea?)

exactly what boot command did you use? it should be as follows:

boot /pci@f2000000/pci-bridge@d/pci9004,7850@2/@2:2,yaboot

you can put that in ofboot.b.

if that is what you used then it looks to me like the scsi card is not
really OF supported, can you boot macos off of it?  (if you have macos)

> One last thing: I have managed in the past week to get ybin working (my
> bootstrap was mounted in the mtab).

yes you bootstrap partition should never be mounted anywhere, not in
linux, not in macos.  treat it like a bootblock that is all it is.
your kernels belong in your ext2 root filesystem.

-- 
Ethan Benson
http://www.alaska.net/~erbenson/